<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>
    <script src="utils.js"></script>

    <link rel="import" href="../dez-canvas.html">
  </head>
  <body>

    <test-fixture id="MultiLinesGridFixture">
      <template>
        <dez-canvas
            grid-data= '{
                "lines": [
                    {"bottom" : 100.0, "top": 5.0},
                    {"bottom" : 200.0, "top": 105.0},
                    {"bottom" : 300.0, "top": 205.0},
                    {"bottom" : 400.0, "top": 305.0}
                ]
            }'
        ></dez-canvas>
      </template>
    </test-fixture>

    <script>

    const VL_WIDTH = 10;
    const VL_TEXT_HEIGHT = 15;
    const HORIZONTAL_MARGIN = 10;
    const RECT_TEXT_H_SPACE = 10;
    const RECT_TEXT_V_SPACE = 20;
    const SVG_TOP_MARGIN = 25
    const TIME_OUT = 100;
    const LINE_HEIGHT = 30
    const INTERLINE = 2
    const NB_TOP_LINES = 3

    suite ('Gestures on multi lines tests', function () {

        setup (function () {
            this._element = fixture('MultiLinesGridFixture');
            this.leftMargin = getLeftMargin(this._element);
            this._svgElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg'));
            this._topHeight = (LINE_HEIGHT + INTERLINE) * NB_TOP_LINES
        })

        test ('Long track down should create a VerticalLine on several lines', function (done) {
          debugger
          this._svgElement.longTapAt(100, 150, () => {
            this._svgElement.trackAt(100,150).moveTo(100,250).stop()
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "vline");
            assert.equal(textElement.getAttribute("y"), 300 + SVG_TOP_MARGIN + this._topHeight);
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - VL_WIDTH/2 - this.leftMargin)
            assert.equal(rectElement.getAttribute("y"), 105 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), VL_WIDTH - 2)
            assert.equal(rectElement.getAttribute("height"), 195 - VL_TEXT_HEIGHT)
            done()
          })
        });

        test ('Long track up should create a VerticalLine on several lines', function (done) {
          this._svgElement.longTapAt(100, 250, () => {
            this._svgElement.trackAt(100,250).moveTo(100,50).stop();
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "vline");
            assert.equal(textElement.getAttribute("y"), 300 + SVG_TOP_MARGIN + this._topHeight);
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - VL_WIDTH/2 - this.leftMargin)
            assert.equal(rectElement.getAttribute("y"), 5 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), VL_WIDTH - 2)
            assert.equal(rectElement.getAttribute("height"), 295 - VL_TEXT_HEIGHT)
            done()
          })
        });

        test ('Long track left and down to several lines should create a Rectangle on several lines', function (done) {
          this._svgElement.longTapAt(100, 50, () => {
            this._svgElement.trackAt(100,50).moveTo(300,250).stop();
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "rectangle");
            assert.equal(textElement.getAttribute("x"), 100 + RECT_TEXT_H_SPACE - this.leftMargin - HORIZONTAL_MARGIN);
            assert.equal(textElement.getAttribute("y"), 5 + RECT_TEXT_V_SPACE + SVG_TOP_MARGIN + this._topHeight);
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - this.leftMargin - HORIZONTAL_MARGIN)
            assert.equal(rectElement.getAttribute("y"), 5 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), 200 + 2*HORIZONTAL_MARGIN - 2)
            assert.equal(rectElement.getAttribute("height"), 295)
            done()
          })
        });

        test ('Long track left and up to several lines should create a Rectangle on several lines', function (done) {
          this._svgElement.longTapAt(100, 250, () => {
            this._svgElement.trackAt(100,250).moveTo(300,50).stop();
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "rectangle");
            assert.equal(textElement.getAttribute("x"), 100 + RECT_TEXT_H_SPACE - this.leftMargin - HORIZONTAL_MARGIN); // 10 = bottom space
            assert.equal(textElement.getAttribute("y"), 5 + RECT_TEXT_V_SPACE + SVG_TOP_MARGIN + this._topHeight); // 10 = bottom space
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - this.leftMargin - HORIZONTAL_MARGIN)
            assert.equal(rectElement.getAttribute("y"), 5 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), 200 + 2*HORIZONTAL_MARGIN - 2)
            assert.equal(rectElement.getAttribute("height"), 295)
            done()
          })
        });

        test ('Long track right and down to several lines should create a Rectangle on several lines', function (done) {
          this._svgElement.longTapAt(300, 50, () => {
            this._svgElement.trackAt(300,50).moveTo(100,250).stop();
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "rectangle");
            assert.equal(textElement.getAttribute("x"), 100 + RECT_TEXT_H_SPACE - this.leftMargin - HORIZONTAL_MARGIN); // 10 = bottom space
            assert.equal(textElement.getAttribute("y"), 5 + RECT_TEXT_V_SPACE + SVG_TOP_MARGIN + this._topHeight); // 10 = bottom space
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - this.leftMargin - HORIZONTAL_MARGIN)
            assert.equal(rectElement.getAttribute("y"), 5 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), 200 + 2*HORIZONTAL_MARGIN - 2)
            assert.equal(rectElement.getAttribute("height"), 295)
            done()
          })
        });

        test ('Long track right and up to several lines should create a Rectangle on several lines', function (done) {
          this._svgElement.longTapAt(300, 250, () => {
            this._svgElement.trackAt(300,250).moveTo(100,50).stop()
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "rectangle");
            assert.equal(textElement.getAttribute("x"), 100 + RECT_TEXT_H_SPACE - this.leftMargin - HORIZONTAL_MARGIN); // 10 = bottom space
            assert.equal(textElement.getAttribute("y"), 5 + RECT_TEXT_V_SPACE + SVG_TOP_MARGIN + this._topHeight); // 10 = bottom space
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - this.leftMargin - HORIZONTAL_MARGIN)
            assert.equal(rectElement.getAttribute("y"), 5 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), 200 + 2*HORIZONTAL_MARGIN - 2)
            assert.equal(rectElement.getAttribute("height"), 295)
            done()
          })
        });

        test ('should create a grob even if track starts on an undefined zone', function (done) {
          this._svgElement.longTapAt(100,2, () => {
            this._svgElement.trackAt(100,2).moveTo(300,250).stop();
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "rectangle");
            assert.equal(textElement.getAttribute("x"), 100 + RECT_TEXT_H_SPACE - this.leftMargin - HORIZONTAL_MARGIN);
            assert.equal(textElement.getAttribute("y"), 5 + RECT_TEXT_V_SPACE + SVG_TOP_MARGIN + this._topHeight);
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - this.leftMargin - HORIZONTAL_MARGIN)
            assert.equal(rectElement.getAttribute("y"), 5 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), 200 + 2*HORIZONTAL_MARGIN - 2)
            assert.equal(rectElement.getAttribute("height"), 295)
            done()
          })
        });

        test ('should create a grob even if track ends on an undefined zone', function (done) {
          this._svgElement.longTapAt(100,50, () => {
            this._svgElement.trackAt(100,50).moveTo(300,302).stop();
            let textElement = this._element.shadowRoot.querySelector("svg>g>text")
            assert.equal(textElement.innerHTML, "rectangle");
            assert.equal(textElement.getAttribute("x"), 100 + RECT_TEXT_H_SPACE - this.leftMargin - HORIZONTAL_MARGIN);
            assert.equal(textElement.getAttribute("y"), 5 + RECT_TEXT_V_SPACE + SVG_TOP_MARGIN + this._topHeight);
            let rectElement = this._element.shadowRoot.querySelector("svg>g>rect")
            assert.equal(rectElement.getAttribute("x"), 100 - this.leftMargin - HORIZONTAL_MARGIN)
            assert.equal(rectElement.getAttribute("y"), 5 + SVG_TOP_MARGIN + this._topHeight)
            assert.equal(rectElement.getAttribute("width"), 200 + 2*HORIZONTAL_MARGIN - 2)
            assert.equal(rectElement.getAttribute("height"), 295)
            done()
          })
        });

    });

    </script>

  </body>
</html>
